%% this script runs different corner detectors for the same image
clear all
close all
clc

%% load image
% Read an image from file
filename = 'tiger.jpg';
I = imread(filename);

% Convert image from RGB to grayscale
if size(size(I), 2) == 3
  I = double(rgb2gray(I) )/255;
else
  I = double(I);
end

%% run harris
figure('Name', 'Harris features', 'NumberTitle', 'off');
harris_corners = detectHarrisFeatures(I);
imshow(I, []); hold on;
plot(harris_corners);

%% run SURF
figure('Name', 'SURF features', 'NumberTitle', 'off');
surf_corners = detectSURFFeatures(I);
imshow(I, []); hold on;
plot(surf_corners.selectStrongest(50));
% if the ouput is not readable due to too many features, you can try:
% plot(surf_corners.selectStrongest(50));

%% you can try other detectors provided by Matlab
% detectFASTFeatures detectSURFFeatures detectBRISKFeatures
% the usage of these functions are similar to the above two