function [ corners ] = harrisCorners( I, patch_size, k, R_threshold, display_intermediate_results )
%HARRISCORNERS Summary of this function goes here
%   Detailed explanation goes here


%% TASK 1: Compute image gradients in x and y direction

% Create filter kernels
% Use the fspecial function to create a sobel filter in x and y direction.
% Type 'doc fspecial' to find the documentation about this function. 
% If you don't remember what the 'Sobel' filter is, have a look at the
% slides from last lecture about filtering.
filter_kernel_dx = % TODO
filter_kernel_dy = filter_kernel_dx';

% Filter the input image
I_x = imfilter(I, filter_kernel_dx, 'replicate');
I_y = % TODO, apply the sobel kernel for the derivative in y direction

% Display results
if display_intermediate_results
    figure('Name', 'Intermediate Results', 'NumberTitle', 'off') 
    subplot(3,3,1)
    imshow(I_x,[])
    title('I_x')
    subplot(3,3,2)
    imshow(I_y,[])
    title('I_y')
end
    
%% TASK 2: Compute components of 2nd moment matrix for every pixel

% Now, we want to compute the components of the M-Matrix for every pixel.
% You find the M-Matrix in equation (5) in the exercise sheet.
I_xx = I_x.*I_x;    % Remember that .* means element-wise multiplication
I_yy = % TODO
I_xy = % TODO

% We compute the corner score by gaussian filtering the M-Matrix in a local 
% neighbourhood. Try with an average filter to compare the results.
filter_kernel_gauss = fspecial('gaussian', [patch_size, patch_size]);
I_xx = % TODO
I_yy = % TODO
I_xy = % TODO

% Display results
if display_intermediate_results
    subplot(3,3,4)
    imshow(I_xx,[])
    title('\Sigma I_x^2')
    subplot(3,3,5)
    imshow(I_yy,[])
    title('\Sigma I_y^2')
    subplot(3,3,6)
    imshow(I_xy,[])
    title('\Sigma I_xI_y')
end

%% TASK 3: Compute Harris score

% TODO: Compute the Harris score R for every pixel
%       refer to equation (8) in the exercise sheet
%       use k from the function parameters
[height, width] = size(I);
R = zeros(height, width); 
R = % TODO

% Display results
if display_intermediate_results
    subplot(3,3,7)
    imshow(R, [])
    title('R')    
end

%% Threshold results

% Having computed the score for every pixel, we need to apply a threshold.
% Pixels above the threshold satisfy our cornerness criterion.
R_thresholded = R > R_threshold;

if display_intermediate_results
    subplot(3,3,8)
    imshow(R_thresholded,[])
    title('R thresholded')    
end

%% Non-Maxima suppression

% As you see, many pixels close to each other satisfy the cornerness
% criterion. Therefore, we need to find in every cluster the one pixel that
% has the highest score and neglect all the others.
% TODO: try to understand what the orderfilt2 function does.
nonmax_radius = 5;                                   
mx = ordfilt2(R,nonmax_radius^2,ones(nonmax_radius));
cm = (R==mx) & R_thresholded;       

[r,c] = find(cm);
corners = [c';r'];

if display_intermediate_results
    subplot(3,3,9)
    imshow(I, [])
    hold on
    plot(c, r,'y.')
    title('nonmaxima suppression')  
end

end

